<template>
  <div class="dashboard-investments-page pt-3 pb-5">
    <h2>Liquidate Investment</h2>
    <div class="mt-3">
      <!-- <div class="d-flex justify-content-end">
        <button class="btn btn-primary">
          <soan class="me-2"> +</soan> New Investment
        </button>
      </div> -->
      <form @submit.prevent="submitForm">
        <div class="row mt-3">
          <div class="col-sm-12 col-md-4">
            <p class="fw-bold">Step 1 - Select Investment type</p>
            <div v-for="(plan, i) in investmentPlans" :key="i" class="mt-3">
              <input
                :id="trimText(plan.investmentPlan.name)"
                v-model="form.activeAccount"
                type="radio"
                name="activeAccount"
                :value="trimText(plan.investmentPlan.name)"
                class="account-radio d-none"
              />
              <label :for="trimText(plan.investmentPlan.name)" class="w-100">
                <div class="investment-type-card">
                  <div class="d-flex">
                    <div>
                      <h5 class="m-0 fw-bold">
                        {{ plan.investmentPlan.name }}
                      </h5>
                    </div>
                  </div>
                  <div>
                    <div class="d-flex justify-content-between">
                      <p class="w-75 m-0">
                        {{ plan.description }}
                      </p>
                    </div>

                    <div class="text-end float-end">
                      <p class="fw-bold m-0">
                        Amount: {{ plan.totalAmount | formatPrice }}
                      </p>
                      <p class="fw-bold m-0">
                        ROI: upto {{ plan.interestRate }}% p.a
                      </p>
                    </div>
                  </div>
                </div>
              </label>
            </div>
          </div>
          <div class="col-sm-12 col-md-4 position-relative">
            <p class="fw-bold">Step 2</p>
            <div class="mt-3">
              <div ref="investmentContent" class="card w-100">
                <!-- <div class="form-group">
                  <p class="fw-bold">How much would you like to liquidate?</p>
                  <label>Transaction PIN</label>
                  <input
                    v-model="form.transactionPin"
                    v-validate="'required'"
                    type="password"
                    class="form-control"
                    name="Transaction PIN"
                  />
                  <div
                    v-show="verrors.has('Transaction PIN')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Transaction PIN') }}
                  </div>
                </div> -->
                <div class="form-group my-4">
                  <label class="mb-2">Enter your PIN</label>
                  <input
                    v-model="form.pin"
                    v-validate="'required'"
                    type="password"
                    class="form-control"
                    name="Transaction PIN"
                  />
                  <div
                    v-show="verrors.has('Transaction PIN')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Transaction PIN') }}
                  </div>
                </div>

                <vs-button :loading="form.active" type="submit" class="w-100">
                  Confirm
                </vs-button>
                <!-- <div class="mt-3">
                <p class="fw-bold">Select fund source</p>
                <CurrentAccountBalance />
                <p class="text-primary fw-bold text-center mt-3">
                  Change Fund Source
                </p>
              </div> -->
              </div>
            </div>
          </div>
          <div class="col-sm-12 col-md-6"></div>
        </div>
      </form>
    </div>

    <!-- Modal -->
    <!-- Successful Modal -->
    <div
      id="PaymentSuccessModal"
      class="modal fade"
      tabindex="-1"
      data-bs-backdrop="static"
    >
      <div class="modal-dialog modal-dialog-centered">
        <div
          class="modal-content d-flex justify-content-center align-items-center"
        >
          <div class="modal-body py-5">
            <div class="text-center">
              <img
                src="@/assets/images/transfer-success-icon.png"
                alt="Transfer Successfull"
              />
            </div>
            <div class="px-5 text-center mt-3">
              <h3 class="fw-bold text-dark my-2">Successful!</h3>
              <p class="text-muted my-2 px-3">
                Your investment has been successfully updated and would take
                effect immediately
              </p>

              <div class="mt-3">
                <div class="d-flex justify-content-center">
                  <button
                    data-bs-dismiss="modal"
                    type="button"
                    class="btn btn-primary btn-lg rounded-1 px-5 h6"
                    style="font-size: 14px"
                  >
                    <span class="px-2"> OK </span>
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  components: {},
  layout: 'dashboard',
  async asyncData({ $axios }) {
    const investmentPlans = await $axios.$get(
      '/investment/user/active?page=1&limit=10'
    )
    const userAccounts = await $axios.$get('/user/accounts')
    // console.log(investmentPlans)
    return {
      investmentPlans: investmentPlans.payload.data,
      userAccounts: userAccounts.payload,
    }
  },
  data: () => ({
    durations: [],
    form: {
      activeAccount: '',
      active: false,
      duration: null,
    },
  }),
  computed: {
    currentInvestment() {
      const that = this
      return this.investmentPlans.find(function (inv) {
        // console.log(this.trimText(inv.name))
        return (
          that.trimText(inv.investmentPlan.name) === that.form.activeAccount
        )
      })
    },
  },
  created() {
    this.form.activeAccount = this.trimText(
      this.investmentPlans[0].investmentPlan &&
        this.investmentPlans[0].investmentPlan.name
    )
    this.form.accountFrom = this.userAccounts[0]
  },
  mounted() {},
  methods: {
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    trimText(text) {
      // console.log(text)
      return text.replace(/\s+/g, '-').toLowerCase()
    },
    submitForm() {
      this.$validator.validateAll().then((result) => {
        if (result) {
          const data = {
            transactionPin: this.form.pin,
          }
          this.form.active = true
          this.$axios
            .patch(`/investment/liquidate/${this.currentInvestment.id}`, data)
            .then(({ data }) => {
              console.log(data)
              this.form.active = false
              // eslint-disable-next-line
              const modal = new bootstrap.Modal(
                document.getElementById('PaymentSuccessModal'),
                {}
              )
              modal.show()
              this.openNotification('top-left', 'success', data.message)
            })
            .catch((error) => {
              // console.log(error)
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406 ||
                error.response.status === 409
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              } else {
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-investments-page {
  .investment-details-card {
    background: #ffffff;
    border-radius: 20px;
    min-height: 300px;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  input.form-control,
  .form-select,
  textarea.form-control {
    background-color: #f4f2ec;
    border-radius: 5px;
    border: none;
  }

  input.account-radio:checked + label {
    .investment-type-card {
      // background-color: red;
      background-position: 98% 4%, right top;
      background-image: url(~@/assets/images/tick.png),
        url(~@/assets/icons/image-26.svg);
    }
  }
  .investment-type-card,
  .coreflex-card {
    min-height: 200px;
    width: 100%;
    background-color: #fff;
    background-image: url(~@/assets/icons/image-26.svg);
    border-radius: 20px;
    padding: 16px 20px;
    background-repeat: no-repeat;
    background-position: right top;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    margin-bottom: 20px;
  }
}
</style>
